# Введение

## Поряд работы с библиотекой:
1. Установить плагин.

    ``` sh
    $pip install autodeploy
    ```
2. Создать файл fabfile.py

    ``` sh
    $touch fabfile.py
    ```
3. В модуле `fabfile` сделать импорт из модуля `fablib` следующих функций:
    * init - функция для инициализации проекта на сервере. 
    * deploy - функция обновления проекта на сервере.
    * rollback - функция для отката приложения на определенную версию.
    * clear - функция удаления директории с проектом.
    ``` python
    from autodeploy.fablib import init, deploy, rollback, clear
    ```
4. Запустить функцию из консоли командой `fab init:some.yaml`, где
    * `fab` - ключевое слово для библиотеки `fabric`
    * `init` - одна из функций модуля `fablib`. Может быть заменена на `deploy` или `rollback`.
    * `some.yaml` - yaml файл с конфигурацией проекта на сервере.
    Указывать `yaml`-файл не обязательно, по умолчанию берется файл `production.yaml` из папки `config`.
    

## Содержание файла с конфигурациями

### Параметры конфигурации:
#### Необязательные параметры(их можно не указывать):
1. `branch` - ветка с проектом. По умолчанию `master`.
2. `venv_requirements` - имя файла с указанием всех библиотек и их версий.
По умолчанию `requirements.txt`.
3. `venv_folder` - имя папки виртуального окружения.

#### Обязательные параметры(без них работать не будет):
1. `hosts` - список хостов. Указывается в таком формате: `user@host:port`.
2. `work_service` - сервис, который взаимодействует с сервиром. 
Он будет запущен при инициализации и перезагружен при обновлении или откате.
Если сервер не использует какой-либо сервис то, в качестве параметра следует указать `null`.
3. `path` - путь к каталогу с проектом.
4. `repository` - путь к репозиторию с проектом.
5. `path_key` - путь по которому можно найти публичный ключ для входа на сервер.
6. `migrate_command` - команда для миграции базы данных. При отсутствии таковой команды можно указать `null`

[Пример файла с конфигурациями.](../files/myservers.yaml.example)


## Параметры запуска функций
### `init` и `deploy`
Для удобства можно воспользоваться возможностью указать сервис в настройках запуска, например:
 `fab init:some.yaml,service=nginx`
 `fab deploy:some.yaml,service=nginx`
### `rollback`
По умолчанию при запуске отката типа `fab rollback:some.yaml` произойдет откат на один коммит назад.
Для отката к определенному коммиту следует воспользоваться параметром `commit_hash`, например:
`fab rollback:some.yaml,commit_hash=92s29f7`
### `clear`
Удаление папки с проектом. Удобно использовать при возникновении ошибки в процессе инициализации проекта.


**[Обратно к README](../README.md)**
